<?php
/**
 * $Horde: rakim/admin/editScript.php,v 1.8 2004/11/22 20:04:35 chuck Exp $
 */

@define('RAKIM_BASE', dirname(__FILE__) . '/..');
require_once RAKIM_BASE . '/lib/base.php';

if (!Auth::isAdmin('rakim:admin')) {
    Horde::authenticationFailureRedirect();
}

$pick = false;
$text = Util::getPost('shared_script_text_entered');
$rtitle = Util::getPost('shared_script_title_entered');

if (Util::getPost('delScript')) {
    $pick = true;
    $deleteQuery = 'DELETE FROM rakim_canned_messages WHERE canned_message_id = ' . (int)Util::getPost('shared_script_id');
    Horde::logMessage($deleteQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($deleteQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(sprintf(_("An error occurred deleting this response: %s"), $result->getMessage()), 'horde.error');
    } elseif (!$db->affectedRows()) {
        $notification->push(_("The shared response was not found."), 'horde.error');
    } else {
        $notification->push(sprintf(_("The shared response (ID %s) was successfully deleted."), Util::getPost('shared_script_id')), 'horde.success');
    }
} elseif (Util::getPost('shared_script_id')) {
    $getScriptInfoQuery = 'SELECT * FROM rakim_canned_messages WHERE canned_message_id = ' . (int)Util::getPost('shared_script_id');
    $result = $db->query($getScriptInfoQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(_("The response was not found."), 'horde.error');
        $pick = true;
    } else {
        $row = $result->fetchRow(DB_FETCHMODE_ASSOC);
        $rtitle = $row['canned_message_title'];
        $text = $row['canned_message_text'];
        $id = $row['canned_message_id'];
    }
} elseif (Util::getPost('shared_script_id_entered')) {
    $id = Util::getPost('shared_script_id_entered');
    if (!$text) {
        $notification->push(_("You must enter the text for this canned response."), 'horde.error');
        addScriptForm($shared_script_title_entered, "", $shared_script_id_entered);
    } elseif (!$rtitle) {
        $notifcation->push(_("You must enter a title for this canned response."), 'horde.error');
        addScriptForm("", $shared_script_text_entered, $shared_script_id_entered);
    } else {
        $updateScriptInfoQuery = 'UPDATE rakim_canned_messages SET canned_message_title = ' . $db->quote($rtitle) . ', canned_message_text = ' . $db->quote($text) . ' WHERE canned_message_id = ' . (int)$id;
        Horde::logMessage($updateScriptInfoQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

        $result = $db->query($updateScriptInfoQuery);
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
            $notification->push(sprintf(_("There was an error updating this response: %s"), $result->getMessage()), 'horde.error');
        } else {
            $notification->push(sprintf(_("The shared response '%s' was successfully updated."), $rtitle), 'horde.success');
            $pick = true;
        }
    }
} else {
    $pick = true;
}

$title = _("Edit/Delete a Shared Response");
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';

if ($pick) {
    require RAKIM_TEMPLATES . '/admin/pickScript.inc';
    pickScriptForm();
} else {
    require RAKIM_TEMPLATES . '/admin/addScript.inc';
    addScriptForm($rtitle, $text, $id);
}
require $registry->get('templates', 'horde') . '/common-footer.inc';
