<?php
/**
 * $Horde: rakim/bounce.php,v 1.15 2004/10/19 00:46:03 chuck Exp $
 */

define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

if (!Util::getPost('prompted')) {
    if (!Util::getPost('categorized')) {
        require RAKIM_TEMPLATES . '/common-header.inc';
        require RAKIM_TEMPLATES . '/bounce/categorize.inc';
        require $registry->get('templates', 'horde') . '/common-footer.inc';
        exit;
    } else {
        // Store categorization for this session.
        $qtypes = Util::getPost('qtypes');
        $resolution = Util::getPost('resolution');
        if (!is_array($qtypes) || !count($qtypes)) {
            $notification->push(_("Please select at least one question type."), 'horde.error');
            require RAKIM_TEMPLATES . '/common-header.inc';
            $notification->notify(array('listeners' => 'status'));
            require RAKIM_TEMPLATES . '/bounce/categorize.inc';
            require $registry->get('templates', 'horde') . '/common-footer.inc';
            exit;
        }

        $statusQuery = 'UPDATE rakim_queues SET queue_resolution = ' . $db->quote($resolution) . ', queue_question_types = ' . $db->quote(implode(', ', $qtypes)) . ' WHERE guest_id = ' . (int)$_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']] . ' AND user_uid = ' . $db->quote(Auth::getAuth());
        Horde::logMessage($statusQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

        $result = $db->query($statusQuery);
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        }
    }
}

if ($prefs->getValue('send_transcript') == 'prompt' && !Util::getPost('prompted')) {
    require RAKIM_TEMPLATES . '/common-header.inc';
    require RAKIM_TEMPLATES . '/bounce/transcript.inc';
    require $registry->get('templates', 'horde') . '/common-footer.inc';
    exit;
}

if (empty($_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']])) {
    $result = false;
} else {
    $checkQueueQuery = "SELECT queue_id FROM rakim_queues WHERE guest_id = " . $_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']] . " AND queue_status != 'exit' AND user_uid = " . $db->quote(Auth::getAuth());
    Horde::logMessage($checkQueueQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);
    $result = $db->query($checkQueueQuery);
}

if (is_a($result, 'PEAR_Error')) {
    Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
} elseif ($result && $result->numRows()) {
    $checkQueues = 'SELECT queue_id FROM rakim_queues WHERE queue_status != \'exit\' AND user_uid != ' . $db->quote(Auth::getAuth());
    $result = $db->query($checkQueues);
    $bounce = is_a($result, 'PEAR_Error') ? 't' : $result->numRows() ? 'f' : 't';
    if ($prefs->getValue('guest_farewell')) {
        sendGuestMessage($prefs->getValue('guest_farewell'), $_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']], 'f', $bounce);
    } else {
        sendGuestMessage(_("I have left this session."), $_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']], 'f', $bounce);
    }

    // We won't change the values in the table if the guest has
    // already left.
    $updateQueueQuery = "UPDATE rakim_queues SET queue_status = 'exit', queue_exit_time = " . time() . "
        WHERE guest_id = " . $_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']] . " AND queue_status != 'exit' AND user_uid = " . $db->quote(Auth::getAuth());

    $result = $db->query($updateQueueQuery);
}

if ($prefs->getValue('send_transcript') == 'yes' || Util::getPost('promptSendTranscript')) {
    require_once 'Horde/Identity.php';
    $identity = &Identity::singleton();
    Rakim::mailTranscript($identity->getValue('from_addr'), null, $_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']]);
}

unset($_SESSION['rakim']['queue_ids'][$_SESSION['rakim']['guestNumber']]);
unset($_SESSION['rakim']['guest_ids'][$_SESSION['rakim']['guestNumber']]);
unset($_SESSION['rakim']['guest_names'][$_SESSION['rakim']['guestNumber']]);
unset($_SESSION['rakim']['guest_messages'][$_SESSION['rakim']['guestNumber']]);
unset($_SESSION['rakim']['guest_remote_addrs'][$_SESSION['rakim']['guestNumber']]);

Rakim::compressQueues();
$_SESSION['rakim']['guestNumber'] = 0;
@session_write_close();

?>
<script language="JavaScript" type="text/javascript">
window.setTimeout("top.rakim_monitor.location.href = '<?php echo Horde::applicationUrl('monitor.php', true) ?>'", 0); 
window.setTimeout("top.rakim_messages.location.href = '<?php echo Horde::applicationUrl('messages.php?guestNumber=0', true) ?>'", 0); 
window.setTimeout("top.rakim_input.location.href = '<?php echo Horde::applicationUrl('techInput.php', true) ?>'", 0); 
window.setTimeout("top.rakim_tabs.location.href = '<?php echo Horde::applicationUrl('tabs.php', true) ?>'", 0); 
</script>
