<?php
/**
 * $Horde: rakim/emailReply.php,v 1.17 2004/11/22 20:04:35 chuck Exp $
 */

@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once 'Horde/Text/Filter.php'; 

function replyForm($question_id)
{
    global $db, $rakim, $title;

    $selectQuery = "SELECT * FROM rakim_emails
        WHERE email_id = " . (int)$question_id . "
        AND (email_status = 'claimed' OR email_status = 'replied' OR email_status = 'forwarded')
        AND email_user_uid = " . $db->quote(Auth::getAuth());

    Horde::logMessage($selectQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($selectQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
    } elseif (!$result->numRows()) {
        echo '<span class="light">' . _("You are not allowed to reply to this request.") . '</span>';
    } else {
        $email = $result->fetchRow(DB_FETCHMODE_ASSOC);
?>

<form method="post" action="emailReply.php" name="reply">
<?php Util::pformInput() ?>
<table border="0" cellpadding="2" cellspacing="0" align="center" width="100%">
<tr>
  <td class="header" colspan="2"><?php echo $title ?></td>
</tr>
<tr>
  <td width="100%" colspan="2" class="control">
   <table border="0" cellpadding="2" cellspacing="1" width="100%">
    <tr>
     <td nowrap="nowrap" width="10%" align="right" class="item0"><b><?php echo _("From") ?></b></td><td width="90%" class="item0"><?php echo htmlspecialchars($email['guest_email']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Organization") ?></b></td><td class="item1"><?php echo htmlspecialchars($rakim->getOrganization($email['guest_organization'])) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("User Type") ?></b></td><td class="item0"><?php echo htmlspecialchars($email['guest_type']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Question Category") ?></b></td><td class="item1"><?php echo htmlspecialchars($email['guest_question_category']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("Request Received") ?></b></td><td class="item0"><?php echo strftime('%x %X', $email['email_time_asked']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'claimed' || $email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Request Claimed") ?></b></td><td class="item1"><?php echo strftime('%x %X', $email['email_time_claimed']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("Requested First Answered") ?></b></td><td class="item0"><?php echo strftime('%x %X', $email['email_time_answered']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Request Closed") ?></b></td><td class="item1"><?php echo strftime('%x %X', $email['email_time_closed']) ?></td>
    </tr>
    <?php endif; ?>
    <?php endif; ?>
    <?php endif; ?>

    <tr>
     <td colspan="2" class="control">&nbsp;</td>
    </tr>

    <tr>
     <td colspan="2" class="control"><b><?php echo _("Original Question") ?></b></td>
    </tr>
    <tr>
     <td colspan="2" class="text"><blockquote><?php echo Text_Filter::filter($email['email_text'], 'text2html', array('parselevel' => TEXT_HTML_MICRO)) ?></blockquote></td>
    </tr>

    <tr>
     <td colspan="2" class="control"><b><?php echo _("Response") ?></b></td>
    </tr>
    <tr>
     <td colspan="2" class="control">
        <textarea class="fixed" name="response" cols="70" rows="20"><?php
        if (Util::getFormData('response')) {
            echo htmlspecialchars(Util::getFormData('response'));
        } else {
            echo _("You asked:") . "\n\n&gt; " . htmlspecialchars(String::wrap($email['email_text'], 70, "\r\n> ")) . "\n\n";
        }
        $responses = $rakim->getEmailResponses($email['email_id']);
        foreach ($responses as $response) {
            printf(_("On %s, %s replied:"), strftime('%x %X', $response['response_time']), $response['user_uid']);
            echo "\n\n&gt; " . htmlspecialchars(String::wrap($response['response_text'], 70, "\r\n> ")) . "\n\n";
        }
        ?></textarea>
     </td>
    </tr>

   </table>
  </td>
</tr>

<tr>
  <td colspan="2">
    <input type="hidden" name="question_id" value="<?php echo $email['email_id'] ?>" />
    <input class="button" type="submit" name="reply" value="<?php echo _("Reply") ?>" />
    <input class="button" type="submit" name="close" value="<?php echo _("Reply and Close") ?>" />
    <input class="button" type="button" name="cancel" onclick = "window.location = '<?php echo Horde::applicationUrl('emailView.php?id=' . $email['email_id']) ?>';" value="<?php echo _("Back to this Email") ?>" />
  </td>
</tr>

</table>
</form>
<script language="JavaScript" type="text/javascript">
document.reply.response.focus();
</script>
<?php
    }
}

$question_id = Util::getPost('question_id');
if ($question_id) {
    $response = trim(Util::getPost('response'));

    if (!$response) {
        $notification->push(_("You must supply a non-empty response."), 'horde.error');
    } else {
        $replyQuery = "UPDATE rakim_emails
            SET email_status = 'replied'
            WHERE email_id = " . (int)$question_id . "
                AND email_user_uid = " . $db->quote(Auth::getAuth()) . "
                AND (email_status = 'claimed' OR email_status = 'replied' OR email_status = 'forwarded')";

        $result = $db->query($replyQuery);
        if (is_a($result, 'PEAR_Error')) {
            $notification->push(sprintf(_("There was an error processing your reply: %s"), $result->getMessage()), 'horde.error');
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        } else {
            // Set the answered time if it hasn't yet been set.
            $timeQuery = 'UPDATE rakim_emails SET email_time_answered = ' . time() . ' WHERE email_time_answered IS NULL';
            $db->query($timeQuery);

            $respId = $db->nextId('rakim_email_responses_id');
            if (is_a($respId, 'PEAR_Error')) {
                Horde::logMessage($respId, __FILE__, __LINE__, PEAR_LOG_ERR);
                $notification->push(sprintf(_("There was an error processing your reply: %s"), $respId->getMessage()), 'horde.error');
            } else {
                $respQuery = sprintf('INSERT INTO rakim_email_responses (response_id, email_id, user_uid, response_time, response_text)' .
                                     ' VALUES (%s, %s, %s, %s, %s)',
                                     (int)$respId,
                                     (int)$question_id,
                                     $db->quote(Auth::getAuth()),
                                     time(),
                                     $db->quote($response));
                Horde::logMessage($respQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

                $result = $db->query($respQuery);
                if (is_a($result, 'PEAR_Error')) {
                    $notification->push(sprintf(_("There was an error processing your reply: %s"), $result->getMessage()), 'horde.error');
                    Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
                } else {
                    $selectQuery = "SELECT * FROM rakim_emails WHERE email_id = " . (int)$question_id . "
                        AND email_user_uid = " . $db->quote(Auth::getAuth()) . "
                        AND email_status = 'replied'";

                    Horde::logMessage($selectQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

                    $result = $db->query($selectQuery);
                    if (is_a($result, 'PEAR_Error')) {
                        $notification->push(sprintf(_("There was an error processing your reply: %s"), $result->getMessage()), 'horde.error');
                        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
                    } elseif (!$result->numRows()) {
                        $notification->push(_("You are not allowed to respond to this request."), 'horde.error');
                    } else {
                        $email = $result->fetchRow(DB_FETCHMODE_ASSOC);

                        require_once 'Horde/MIME/Headers.php';
                        require_once 'Horde/MIME/Message.php';
                        require_once 'Horde/MIME/Part.php';

                        $message = String::wrap($response, 70);
                        $message .= "\n\n-----------------------\n\n";
                        $message .= String::wrap(sprintf(_("This email was sent to %s in response to a question you asked on %s."),
                                                       $email['guest_email'], strftime('%x %X', $email['email_time_asked'])), 70);

                        $mime = &new MIME_Message();
                        $body = &new MIME_Part('text/plain', $message);

                        $mime->addPart($body);

                        // Get the supporter's email address.
                        require_once 'Horde/Identity.php';
                        $identity = &Identity::singleton();
                        @list($user, $host) = @explode('@', $identity->getValue('from_addr'));
                        $from = MIME::rfc822WriteAddress($user, $host, $identity->getValue('fullname'));

                        // Build the response headers.
                        $msg_headers = &new MIME_Headers();
                        $msg_headers->addMessageIdHeader();
                        $msg_headers->addHeader('Date', date('r'));
                        $msg_headers->addHeader('From', $from);
                        $msg_headers->addHeader('To', $email['guest_email']);
                        $msg_headers->addHeader('Subject', _("Response to your support request"));
                        $msg_headers->addMIMEHeaders($mime);

                        // Send the response.
                        $result = $mime->send($email['guest_email'], $msg_headers);
                        if (is_a($result, 'PEAR_Error')) {
                            $notification->push(sprintf(_("An error occurred sending your reply: %s"), $result->getMessage()), 'horde.error');
                        } else {
                            $notification->push(_("Your reply was sent."), 'horde.success');
                            if (Util::getFormData('close')) {
                                header('Location: ' . Util::addParameter(Horde::applicationUrl('emailView.php?id=' . $email['email_id'], true), 'close', 1));
                            } else {
                                header('Location: ' . Horde::applicationUrl('emailView.php?id=' . $email['email_id'], true));
                            }
                            exit;
                        }
                    }
                }
            }
        }
    }
}

$id = Util::getFormData('id', $question_id);
$title = sprintf(_("Replying to Request %s"), $id);
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';
replyForm($id);
require $registry->get('templates', 'horde') . '/common-footer.inc';
