<?php
/**
 * $Horde: rakim/emailView.php,v 1.20 2004/11/22 20:04:35 chuck Exp $
 */

@define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';
require_once 'Horde/Text.php';
require_once 'Horde/Text/Filter.php'; 

function showEmail($email)
{
    global $db, $rakim;
?>

<table border="0" cellpadding="1" cellspacing="0" align="center" width="100%">
<tr>
  <td class="header" colspan="2"><?php printf(_("Viewing Email Request: %s"), $email['email_id']) ?></td>
</tr>
<tr>
  <td class="<?php echo $email['email_status'] ?>" colspan="2"><b>
  <?php echo _("Request Status: ") ?>
  <?php
    if ($email['email_status'] == 'open') {
        echo _("Open");
    } elseif ($email['email_status'] == 'claimed') {
        echo _("Claimed");
    } elseif ($email['email_status'] == 'replied') {
        echo _("Replied");
    } elseif ($email['email_status'] == 'forwarded') {
        echo _("Forwarded");
    } elseif ($email['email_status'] == 'closed') {
        echo _("Closed");
    }
    if ($email['email_status'] != 'open') {
        printf(', ' . _("Owner: %s"), $email['email_user_uid']);
    }
  ?>
  </b>
  </td>
</tr>
<tr>
  <td width="100%" colspan="2" class="control">
   <table border="0" cellpadding="2" cellspacing="1" width="100%">
    <tr>
     <td nowrap="nowrap" width="10%" align="right" class="item0"><b><?php echo _("From") ?></b></td><td width="90%" class="item0"><?php echo htmlspecialchars($email['guest_email']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Organization") ?></b></td><td class="item1"><?php echo htmlspecialchars($rakim->getOrganization($email['guest_organization'])) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("User Type") ?></b></td><td class="item0"><?php echo htmlspecialchars($email['guest_type']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Question Category") ?></b></td><td class="item1"><?php echo htmlspecialchars($email['guest_question_category']) ?></td>
    </tr>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("Request Received") ?></b></td><td class="item0"><?php echo strftime('%x %X', $email['email_time_asked']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'claimed' || $email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Request Claimed") ?></b></td><td class="item1"><?php echo strftime('%x %X', $email['email_time_claimed']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item0"><b><?php echo _("Request First Answered") ?></b></td><td class="item0"><?php echo strftime('%x %X', $email['email_time_answered']) ?></td>
    </tr>
    <?php if ($email['email_status'] == 'closed'): ?>
    <tr>
     <td nowrap="nowrap" align="right" class="item1"><b><?php echo _("Request Closed") ?></b></td><td class="item1"><?php echo strftime('%x %X', $email['email_time_closed']) ?></td>
    </tr>
    <?php endif; ?>
    <?php endif; ?>
    <?php endif; ?>

    <tr>
     <td colspan="2">&nbsp;</td>
    </tr>

    <tr>
     <td colspan="2" class="item"><b><?php echo _("Original Question") ?></b></td>
    </tr>
    <tr>
     <td colspan="2" class="text"><blockquote><?php echo Text_Filter::filter($email['email_text'], 'text2html', array('parselevel' => TEXT_HTML_MICRO)) ?></blockquote></td>
    </tr>

    <?php $responses = $rakim->getEmailResponses($email['email_id']); foreach ($responses as $response): ?>
    <tr>
     <td colspan="2" class="item"><b><?php printf(_("Reply by %s on %s"), $response['user_uid'], strftime('%x %X', $response['response_time'])) ?></b></td>
    </tr>
    <tr>
     <td colspan="2" class="text"><blockquote><?php echo Text_Filter::filter($response['response_text'], 'text2html', array('parselevel' => TEXT_HTML_MICRO)) ?></blockquote></td>
    </tr>
    <?php endforeach; ?>

   </table>
  </td>
</tr>

<?php if ($email['email_status'] == 'open' || (($email['email_status'] == 'replied' || $email['email_status'] == 'forwarded' || $email['email_status'] == 'claimed') && $email['email_user_uid'] != Auth::getAuth() && Auth::isAdmin('rakim:admin'))) { ?>
<tr>
  <td colspan="2">
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('emailClaim.php?id=' . $email['email_id'], true) ?>';" value="<?php echo _("Claim") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Util::addParameter(Horde::applicationUrl('emailClaim.php?id=' . $email['email_id'], true), 'reply', 1) ?>';" value="<?php echo _("Claim and Reply") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Util::addParameter(Horde::applicationUrl('emailClaim.php?id=' . $email['email_id'], true), 'forward', 1) ?>';" value="<?php echo _("Claim and Forward") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Util::addParameter(Horde::applicationUrl('emailClaim.php?id=' . $email['email_id'], true), 'close', 1) ?>';" value="<?php echo _("Claim and Close") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('emailList.php') ?>';" value="<?php echo _("Back to List") ?>" />
  </td>
</tr>
  <?php } elseif (($email['email_status'] == 'claimed' || $email['email_status'] == 'replied' || $email['email_status'] == 'forwarded') && ($email['email_user_uid'] == Auth::getAuth())) { ?>
<tr>
  <td colspan="2">
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('emailReply.php?id=' . $email['email_id'], true) ?>';" value="<?php echo _("Reply") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('emailForward.php?id=' . $email['email_id'], true) ?>';" value="<?php echo _("Forward") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Util::addParameter(Horde::applicationUrl('emailView.php?id=' . $email['email_id'], true), 'close', 1) ?>';" value="<?php echo _("Close") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('emailList.php') ?>';" value="<?php echo _("Back to List") ?>" />
  </td>
</tr>
  <?php } elseif ($email['email_status'] == 'closed') { ?>
<tr>
  <td colspan="2">
    <input class="button" type="button" onclick="window.location = '<?php echo Util::addParameter(Horde::applicationUrl('emailView.php?id=' . $email['email_id']), 'reopen', 1) ?>';" value="<?php echo _("Reopen") ?>" />
    <input class="button" type="button" onclick="window.location = '<?php echo Horde::applicationUrl('emailList.php') ?>';" value="<?php echo _("Back to List") ?>" />
  </td>
</tr>
    <?php
    }
?>
</table>
<?php
}

$selectQuery = 'SELECT * FROM rakim_emails WHERE email_id = ' . (int)Util::getFormData('id');
Horde::logMessage($selectQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

$result = $db->query($selectQuery);
if (is_a($result, 'PEAR_Error') || !$result->numRows()) {
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
    }

    $notification->push(_("Email Request not found."), 'horde.error');
    header('Location: ' . Horde::applicationUrl('emailList.php', true));
    exit;
}

$row = $result->fetchRow(DB_FETCHMODE_ASSOC);

// Close the email if requested.
if (Util::getFormData('close') && $row['email_user_uid'] == Auth::getAuth() && ($row['email_status'] == 'claimed' || $row['email_status'] == 'replied' || $row['email_status'] == 'forwarded')) {
    $time = time();
    $closeQuery = 'UPDATE rakim_emails SET email_status = \'closed\', email_time_closed = ' . $time . ' WHERE email_id = ' . (int)$row['email_id'];
    Horde::logMessage($closeQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($closeQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(sprintf(_("There was an error closing this request: %s"), $result->getMessage()), 'horde.error');
    } else {
        $notification->push(_("Successfully closed this request."), 'horde.success');
        $row['email_status'] = 'closed';
        $row['email_time_closed'] = $time;
    }
} elseif (Util::getFormData('reopen')) {
    $reopenQuery = 'UPDATE rakim_emails SET email_status = \'open\', email_time_closed = NULL WHERE email_id = ' . (int)$row['email_id'];
    Horde::logMessage($reopenQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($reopenQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        $notification->push(sprintf(_("There was an error reopening this request: %s"), $result->getMessage()), 'horde.error');
    } else {
        $notification->push(_("Successfully reopened this request."), 'horde.success');
        $row['email_status'] = 'open';
    }
}

$title = sprintf(_("Email Request %s"), Util::getFormData('id'));
require RAKIM_TEMPLATES . '/common-header.inc';
require RAKIM_TEMPLATES . '/menu.inc';
showEmail($row);
require $registry->get('templates', 'horde') . '/common-footer.inc';
