<?php
/**
 * $Horde: rakim/guest/logout.php,v 1.12 2004/11/22 20:04:36 chuck Exp $
 */

@define('AUTH_HANDLER', true);
@define('RAKIM_BASE', dirname(__FILE__) . '/..');
require_once RAKIM_BASE . '/lib/base.php';

function guestLogout()
{
    global $db;

    $guestLogoutQuery = "UPDATE rakim_guests SET guest_logoff_time = " . time() . ", guest_refresh_time = NULL WHERE guest_id = " . $_SESSION['rakim']['guest_id'] . " AND session_id = " . $db->quote(session_id());

    Horde::logMessage($guestLogoutQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $res = $db->query($guestLogoutQuery);
    if (is_a($res, 'PEAR_Error')) {
        Horde::logMessage($res, __FILE__, __LINE__, PEAR_LOG_ERR);
        return false;
    } else {
        return $db->affectedRows($res);
    }
}

function guestExit()
{
    global $db, $registry;

    $gid = $_SESSION['rakim']['guest_id'];
    Horde::getCleanSession();

    // Don't update the queue's exit time if the support person has
    // already left the queue.
    $exitGuestQuery = "UPDATE rakim_queues SET queue_status = 'exit', queue_exit_time = " . time() . " WHERE queue_status != 'exit' AND guest_id = " . (int)$gid;
    Horde::logMessage($exitGuestQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    $result = $db->query($exitGuestQuery);
    if (is_a($result, 'PEAR_Error')) {
        Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
        return false;
    } else {
        return true;
    }
}

// Check for transcript requests; only mail it if there is a
// transcript key, an email address, and the user logged out recently.
if (Util::getFormData('transcriptKey') &&
    !empty($_SESSION['rakim_send_transcript']) &&
    time() - $_SESSION['rakim_send_transcript'] < 360) {

    if (Util::getPost('emailAddress')) {
        Rakim::mailTranscript(Util::getPost('emailAddress'), Util::getPost('transcriptKey'));
        $notification->push(sprintf(_("The transcript was mailed to %s."), Util::getPost('emailAddress')), 'horde.success');
        $transcript_sent = true;
    }
    $transcriptKey = Util::getPost('transcriptKey');
    unset($_SESSION['rakim_send_transcript']);

    $title = _("Transcript Sent");
    require RAKIM_TEMPLATES . '/common-header.inc';
    require RAKIM_TEMPLATES . '/menu.inc';
    require RAKIM_TEMPLATES . '/guest/logout/header.inc';
    require RAKIM_TEMPLATES . '/guest/logout/transcript.inc';
    require $registry->get('templates', 'horde') . '/common-footer.inc';
    exit;
}

// Filter out anyone without a transcript key trying to get in here.
Rakim::checkAuthentication();

if (empty($_SESSION['rakim']['guest_id'])) {
    // User is already logged out or never was logged in.
    header('Location: ' . Horde::applicationUrl('guest/index.php', true));
    exit;

} else {
    guestLogout();

    $transcriptKey = session_id();
    $emailAddress = $_SESSION['rakim']['guest_email'];
    if ($emailAddress) {
        Rakim::mailTranscript($emailAddress, $transcriptKey);
        $notification->push(sprintf(_("The transcript was mailed to %s."), $emailAddress), 'horde.success');
        $transcript_sent = true;
    }

    sendGuestMessage(_("I've left the system"), $_SESSION['rakim']['guest_id']);
    guestExit();

    if ($conf['authentication']['guest'] == 'external') {
        $entry = sprintf('User %s [%s] logged out of Rakim',
                         Auth::getAuth(), $_SERVER['REMOTE_ADDR']);
        Horde::logMessage($entry, __FILE__, __LINE__, PEAR_LOG_NOTICE);
        Auth::clearAuth('rakim_techs');
        session_destroy();

        Horde::setupSessionHandler();
        @session_start();
    }
    $_SESSION['rakim_send_transcript'] = time();

    $title = _("Exiting");
    require RAKIM_TEMPLATES . '/common-header.inc';
    require RAKIM_TEMPLATES . '/menu.inc';
    require RAKIM_TEMPLATES . '/guest/logout/header.inc';

    if ($transcriptKey) {
        require RAKIM_TEMPLATES . '/guest/logout/transcript.inc';
    }
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
