<?php
/**
 * $Horde: rakim/responses.php,v 1.12 2004/10/19 00:46:03 chuck Exp $
 */

define('RAKIM_BASE', dirname(__FILE__));
require_once RAKIM_BASE . '/lib/base.php';

function scriptForm($scriptTitle = '', $scriptText = '', $canned_message_id = '')
{
    global $db, $notification, $registry;

    $notification->push('document.canned_response.scriptTitle.focus()', 'javascript');
    require RAKIM_TEMPLATES . '/common-header.inc';
    $notification->notify(array('listeners' => 'status'));
?>

<form name="canned_response" action="responses.php" method="post">
<?php Util::pformInput() ?>
<table cellpadding="2" border="0" cellspacing="1" align="center">
    <td class="light" align="right"><label for="title"><?php echo _("Response Title") ?></label></td><td><input id="title" type="text" name="scriptTitle" size="25" value="<?php echo $scriptTitle ?>" /></td>
</tr>
<tr>
    <td class="light" align="right"><label for="text"><?php echo _("Response Text") ?></label></td><td><input type="text" name="scriptText" size="25" id="text" value="<?php echo $scriptText; ?>" />
    <?php if ($canned_message_id): ?>
    <input type="hidden" name="canned_message_id" value="<?php echo $canned_message_id ?>" />
    <?php endif; ?>
    </td>
</tr>
<tr>
<tr>
    <td align="center" colspan="2">
      <input class="button" type="submit" name="submitScript" value="<?php echo _("Add Canned Response") ?>" />
      <input class="button" type="button" name="cancel" value="<?php echo _("Cancel") ?>" onclick="if (window.confirm('<?php echo addslashes(_("Really cancel adding/editing this script?")) ?>')) window.location.href = '<?php echo Horde::applicationUrl('tools.php') ?>';" />
    </td>
</tr>
</table>
</form>

<?php

}

if (Util::getPost('scriptText')) {
    if (!Util::getPost('scriptTitle')) {
        $notification->push(_("You must enter a title for the message."), 'horde.error');
        scriptForm('', Util::getPost('scriptText'), Util::getPost('canned_message_id'));
    } else {
        if (Util::getPost('canned_message_id')) {
            $responseQuery = "UPDATE rakim_canned_messages SET canned_message_text = " . $db->quote(Util::getPost('scriptText')) . ",
                canned_message_title = " . $db->quote(Util::getPost('scriptTitle')) . " 
                WHERE canned_message_id = " . $db->quote(Util::getPost('canned_message_id')) . " AND user_uid = " . $db->quote(Auth::getAuth());
        } else {
            $canned_id = $db->nextId('rakim_canned_messages');
            if (is_a($canned_id, 'PEAR_Error')) {
                Horde::logMessage($canned_id, __FILE__, __LINE__, PEAR_LOG_ERR);
                $notification->push(sprintf(_("There was an error creating the canned response: %s"), $canned_id->getMessage()), 'horde.error');
                scriptForm(Util::getPost('scriptTitle'), Util::getPost('scriptText'), Util::getPost('canned_message_id'));
                require $registry->get('templates', 'horde') . '/common-footer.inc';
                exit;
            }

            $responseQuery = 'INSERT INTO rakim_canned_messages (canned_message_id, user_uid, canned_message_text, canned_message_title)
                VALUES (' . (int)$canned_id . ', ' . $db->quote(Auth::getAuth()) . ', ' . $db->quote(Util::getPost('scriptText')) . ', ' . $db->quote(Util::getPost('scriptTitle')) . ')';
        }

        Horde::logMessage($responseQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

        $result = $db->query($responseQuery);
        if (is_a($result, 'PEAR_Error')) {
            Horde::logMessage($result, __FILE__, __LINE__, PEAR_LOG_ERR);
            $notification->push(sprintf(_("There was an error creating the canned response: %s"), $result->getMessage()), 'horde.error');
            scriptForm(Util::getPost('scriptTitle'), Util::getPost('scriptText'), Util::getFormData('canned_message_id'));
            require $registry->get('templates', 'horde') . '/common-footer.inc';
        } else {
            header('Location: ' . Horde::applicationUrl('tools.php', true));
        }
        exit;
    }
} elseif (Util::getPost('scriptTitle')) {
    $notification->push(_("You must enter text for the canned response"), 'horde.error');
    scriptForm(Util::getPost('scriptTitle'), '', Util::getFormData('canned_message_id'));
} elseif (Util::getFormData('canned_message_id')) {
    $selectScriptQuery = "SELECT canned_message_title, canned_message_text FROM rakim_canned_messages
        WHERE canned_message_id = " . $db->quote(Util::getGet('canned_message_id')) . "
        AND user_uid = " . $db->quote(Auth::getAuth());

    Horde::logMessage($selectScriptQuery, __FILE__, __LINE__, PEAR_LOG_DEBUG);

    list($canned_message_title, $canned_message_text) = $db->getRow($selectScriptQuery);
    if (is_a($canned_message_title, 'PEAR_Error')) {
        Horde::logMessage($canned_message_title, __FILE__, __LINE__, PEAR_LOG_ERR);
    }
    scriptForm($canned_message_title, $canned_message_text, Util::getFormData('canned_message_id'));
} else {
    scriptForm('', '', Util::getFormData('canned_message_id'));
}

require $registry->get('templates', 'horde') . '/common-footer.inc';
